## therion 5.3.15

=== Makefile ===
# common therion objects
export OUTDIR = .
CMNOBJECTS = thdate.o extern/shpopen.o extern/dbfopen.o \
  thexception.o thbuffer.o thmbuffer.o thlogfile.o thtmpdir.o thlocale.o \
  thparse.o thcmdline.o thconfig.o thinput.o thchenc.o thdatabase.o \
  thdataobject.o thdatareader.o thsurvey.o thendsurvey.o thdata.o \
  thperson.o thtf.o thtfangle.o thtflength.o thtfpwf.o \
  thdataleg.o thobjectname.o thinfnan.o thlayout.o thcomment.o \
  thinit.o thdb1d.o thsvxctrl.o thdatastation.o thobjectid.o \
  thobjectsrc.o thgrade.o thlibrary.o thgeomag.o thbezier.o \
  thexport.o thexporter.o thselector.o extern/img.o \
  thexpmodel.o thdb2d00.o thscrapis.o thcs.o thcsdata.o thexptable.o \
  thdb2d.o thscrap.o thendscrap.o th2ddataobject.o thdb2dprj.o \
  thdb2dpt.o thdb2dlp.o thdb2dab.o thdb2dji.o thdb2dmi.o thdb2dcp.o \
  thdb2dxm.o thdb2dxs.o thscraplo.o thscraplp.o thscrapen.o \
  thpoint.o thline.o tharea.o thlegenddata.o thmpost.o thsymbolsets.o \
  thjoin.o thmap.o thexpmap.o thlayoutln.o thlayoutclr.o thexpsys.o thexpuni.o \
  thconvert.o thpdf.o thpdfdbg.o thpdfdata.o thtexfonts.o \
  thsymbolset.o thlang.o thmapstat.o thexpdb.o thpic.o thsketch.o thproj.o \
  extern/lxMath.o extern/lxFile.o thdb3d.o thsurface.o thimport.o thsvg.o thepsparse.o \
  thtrans.o thwarpp.o thwarppt.o thwarppme.o thwarp.o thexpshp.o thattr.o thtex.o \
  extern/poly2tri/common/shapes.o extern/poly2tri/sweep/advancing_front.o extern/poly2tri/sweep/sweep.o extern/poly2tri/sweep/cdt.o extern/poly2tri/sweep/sweep_context.o \
  therion.o extern/proj4/libproj.a 

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = g++
##CC = gcc
##POBJECTS =
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHLINUX
##CCPFLAGS = -DTHLINUX
##LDPFLAGS = -s
##export THPLATFORM = LINUX
##THXTHMKCMD = ./therion


# PLATFORM DEBIAN
CXX = c++
CC = gcc
POBJECTS =
LOCHEXE = loch/loch
CXXPFLAGS = -DTHLINUX
CCPFLAGS = -DTHLINUX
LDPFLAGS = -s
export THPLATFORM = LINUX
THXTHMKCMD = ./therion


# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = extern/getopt.o extern/getopt1.o therion.res extern/getline.o 
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -static -s
##export THPLATFORM = WIN32
##THXTHMKCMD = therion
##OUTDIR = ../therion.bin

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##LOCHEXE = loch/loch
##POBJECTS = extern/getopt.o extern/getopt1.o extern/getline.o
##CXXPFLAGS = -DTHMACOSX
##CCPFLAGS = -DTHMACOSX
##LDPFLAGS =
##export THPLATFORM = MACOSX
##THXTHMKCMD = ./therion

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(LDPFLAGS)

# BUILD OXYGEN
CCBFLAGS = -O2
CXXBFLAGS = -O2
LDBFLAGS = $(LDPFLAGS)

# BUILD RELEASE
##CCBFLAGS = 
##CXXBFLAGS = 
##LDBFLAGS = $(LDPFLAGS)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DTHDEBUG
##LDBFLAGS = 

# BUILD ENDCONFIG


# compiler settings
CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS)
CCFLAGS = -DIMG_API_VERSION=1 -Wall $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(OUTDIR)/,$(POBJECTS)) $(addprefix $(OUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS = 
LDFLAGS = $(LDBFLAGS)


$(OUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<

all: outdirs $(OUTDIR)/therion doc xtherion/xtherion $(LOCHEXE)

outdirs:
	mkdir -p $(OUTDIR)/extern/proj4
	mkdir -p $(OUTDIR)/extern/poly2tri/sweep/
	mkdir -p $(OUTDIR)/extern/poly2tri/common/
	mkdir -p $(OUTDIR)/loch
	mkdir -p $(OUTDIR)/xtherion
	mkdir -p $(OUTDIR)/thbook

$(OUTDIR)/extern/proj4/libproj.a: extern/proj4/*.c extern/proj4/*.h
	make -C ./extern/proj4

$(OUTDIR)/therion:	$(OBJECTS)
	$(CXX) -Wall -o $(OUTDIR)/therion $(OBJECTS) $(LDFLAGS) $(LIBS) 


$(OUTDIR)/therion.res: therion.rc
	windres -i therion.rc -J rc -o $(OUTDIR)/therion.res -O coff

init:
	./therion --print-init-file > therion.ini

install: all
	tclsh makeinstall.tcl $(THPLATFORM)


minor-release:
	perl makerelease.pl

archive: clean
	perl makearchive2.pl

release: clean
	perl makearchive.pl

binary: all doc
	perl makebinary.pl $(THPLATFORM)
  
depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -MM $(CXXFLAGS) *.cxx >> Makefile
	perl makedepend2.pl

library:
	$(THXTHMKCMD) --print-library-src thlibrarydata.thcfg > thlibrarydata.log
	$(THXTHMKCMD) --print-xtherion-src > xtherion/therion.tcl
	perl makelibrary.pl thlibrarydata.log > thlibrarydata.tmp
	perl maketest.pl thlibrarydata.tmp
	perl makefile.pl mv thlibrarydata.tmp thlibrarydata.cxx

thlibrarydata.cxx: thlang/texts.txt
	make library

xtherion/xtherion: xtherion/*.tcl
	make -C ./xtherion

loch/loch: loch/*.h loch/*.cxx loch/*.c
	make -C ./loch

doc: $(OUTDIR)/thbook/thbook.pdf

thbook: $(OUTDIR)/thbook/thbook.pdf

samples: $(OUTDIR)/samples.doc/index.tex

$(OUTDIR)/samples.doc/index.tex:
	make -C samples
	touch thbook/version.tex
	make -C thbook    

$(OUTDIR)/thbook/thbook.pdf: thbook/*.tex
	make -C thbook
  
clean:
	make -C ./xtherion clean
	make -C ./loch clean
	make -C ./samples clean
	make -C ./extern/proj4 clean
	perl makefile.pl rm -q therion ./xtherion/xtherion ./xtherion/xtherion.tcl therion.exe *~ *.log *.o thchencdata/*~ .xtherion.dat ./xtherion/ver.tcl
	perl makefile.pl rm -q xtherion/*~ .xth_thconfig_xth xtherion/screendump thlang/*~
	perl makefile.pl rm -q extern/*.o extern/*~ extern/poly2tri/common/*.o extern/poly2tri/sweep/*.o samples/*~ samples/*.log
	perl makefile.pl rm -q symbols.html therion.res
	perl makefile.pl rm -q tri/*.o tri/*~
	perl makefile.pl rm -q tex/*~
	perl makefile.pl rm -q mpost/*~ examples/*~ examples/therion.log
	perl makefile.pl rm -q core symbols.xhtml cave.kml
	perl makefile.pl rm -q data.3d data.svx data.pos data.pts data.err data.plt
	perl makefile.pl rm -q cave.3d cave.lox cave.thm cave.pdf cave.sql cave.xhtml therion.tcl cave_a.pdf cave_m.pdf cave.vrml cave.wrl cave.3dmf cave.svg cave.tlx
	perl makefile.pl rm -q ./thbook/*~ ./thbook/thbook.log ./thbook/thbook.pdf ./lib/*~ ./mpost/*~ ./tex/*~
	perl makefile.pl rmdir -q doc thTMPDIR samples.doc symbols cave.shp tests/.doc

thmpost.h: mpost/*.mp
	make -C ./mpost

thsymbolsetlist.h: thsymbolsetlist.pl mpost/thTrans.mp
	perl thsymbolsetlist.pl
  
thtex.h: tex/*.tex
	make -C ./tex

thcsdata.h: thcsdata.tcl
	tclsh thcsdata.tcl
  
update:
	make -C ./thlang update

unixify: clean
	tclsh makeunixify.tcl
  
thlangdata.cxx: thlang/texts.txt
	make -C ./thlang

config-debug:
	perl makeconfig.pl BUILD DEBUG
	make -C ./loch config-debug
  
config-release:
	perl makeconfig.pl BUILD RELEASE
	make -C ./loch config-release

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN
	make -C ./loch config-oxygen
  
config-ozone:
	perl makeconfig.pl BUILD OZONE
	make -C ./loch config-ozone

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN
	make -C ./loch config-debian
  
config-linux:
	perl makeconfig.pl PLATFORM LINUX
	make -C ./loch config-linux
  
config-win32:
	perl makeconfig.pl PLATFORM WIN32
	make -C ./loch config-win32
  
config-macosx:
	perl makeconfig.pl PLATFORM MACOSX
	make -C ./loch config-macosx

# external sources
$(OUTDIR)/extern/lxMath.o: loch/lxMath.h loch/lxMath.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxMath.o loch/lxMath.cxx
    
$(OUTDIR)/extern/lxFile.o: loch/lxFile.h loch/lxFile.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxFile.o loch/lxFile.cxx

extern/getopt.o: extern/getopt.c extern/getopt.h
extern/getopt1.o: extern/getopt1.c
extern/img.o: extern/img.c extern/img.h
extern/poly2tri/common/shapes.o: extern/poly2tri/common/shapes.cc extern/poly2tri/common/shapes.h
extern/poly2tri/sweep/advancing_front.o: extern/poly2tri/sweep/advancing_front.cc
extern/poly2tri/sweep/sweep.o: extern/poly2tri/sweep/sweep.cc
extern/poly2tri/sweep/cdt.o: extern/poly2tri/sweep/cdt.cc
extern/poly2tri/sweep/sweep_context.o: extern/poly2tri/sweep/sweep_context.cc

# DEPENDENCIES
$(OUTDIR)/th2ddataobject.o: th2ddataobject.cxx th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
 thexception.h thsymbolset.h thsymbolsetlist.h
$(OUTDIR)/tharea.o: tharea.cxx tharea.h th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
 thexception.h thexpmap.h thexport.h thsymbolset.h thsymbolsetlist.h \
 thlayout.h thlocale.h thlang.h thlangdata.h thline.h
$(OUTDIR)/thattr.o: thattr.cxx thattr.h thmbuffer.h thchenc.h thchencdata.h \
 thparse.h thbuffer.h extern/shapefil.h thexception.h therion.h
$(OUTDIR)/thbezier.o: thbezier.cxx thbezier.h
$(OUTDIR)/thbuffer.o: thbuffer.cxx thbuffer.h
$(OUTDIR)/thchenc.o: thchenc.cxx thchenc.h thchencdata.h thparse.h thbuffer.h \
 thmbuffer.h thchencdata.cxx therion.h thexception.h
$(OUTDIR)/thchencdata.o: thchencdata.cxx
$(OUTDIR)/thcmdline.o: thcmdline.cxx thcmdline.h therion.h thlogfile.h thbuffer.h \
 thconfig.h thmbuffer.h thinput.h thparse.h thexporter.h thexport.h \
 thobjectsrc.h thselector.h thtmpdir.h extern/getopt.h
$(OUTDIR)/thconfig.o: thconfig.cxx thconfig.h thbuffer.h thmbuffer.h thinput.h \
 thparse.h thexporter.h thexport.h thobjectsrc.h thselector.h therion.h \
 thlang.h thlangdata.h thchenc.h thchencdata.h thexception.h thdatabase.h \
 thdataobject.h thperson.h thdate.h thdataleg.h thobjectname.h thinfnan.h \
 thdb1d.h thobjectid.h thdb3d.h loch/lxMath.h thattr.h thdb2d.h \
 thdb2dprj.h thmapstat.h thlegenddata.h thdb2dpt.h thdb2dlp.h thdb2dab.h \
 thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h thscraplo.h \
 thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h thdatareader.h \
 thcsdata.h thproj.h thlogfile.h thinit.h thgeomag.h thgeomagdata.h \
 thlayout.h thsymbolset.h thsymbolsetlist.h thlocale.h thsketch.h thpic.h \
 thcs.h
$(OUTDIR)/thconvert.o: thconvert.cxx thpdfdbg.h thexception.h therion.h thbuffer.h \
 thpdfdata.h thepsparse.h thtexfonts.h
$(OUTDIR)/thcs.o: thcs.cxx thcs.h thcsdata.h thparse.h thbuffer.h thmbuffer.h \
 thexception.h therion.h extern/proj4/proj_api.h thdatabase.h \
 thdataobject.h thperson.h thdate.h thdataleg.h thobjectname.h \
 thobjectsrc.h thinfnan.h thdb1d.h thobjectid.h thdb3d.h loch/lxMath.h \
 thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h thmapstat.h \
 thlegenddata.h thdb2dpt.h thdb2dlp.h thdb2dab.h thdb2dji.h thdb2dmi.h \
 thdb2dcp.h thdb2dxs.h thdb2dxm.h thscraplo.h thlayoutln.h thlayoutclr.h \
 thscrapen.h thscraplp.h
$(OUTDIR)/thcsdata.o: thcsdata.cxx thcsdata.h thparse.h thbuffer.h thmbuffer.h
$(OUTDIR)/thdata.o: thdata.cxx thdata.h thdataleg.h thparse.h thbuffer.h \
 thmbuffer.h thobjectname.h therion.h thobjectsrc.h thinfnan.h \
 thdataobject.h thdatabase.h thdb1d.h thobjectid.h thdb3d.h loch/lxMath.h \
 thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h thmapstat.h \
 thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h thdb2dab.h \
 thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h thscraplo.h \
 thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h thtfangle.h thtf.h \
 thtflength.h thtfpwf.h thexception.h thsurvey.h thlayout.h thsymbolset.h \
 thsymbolsetlist.h thlocale.h thgrade.h thcsdata.h thdatareader.h \
 thinput.h
$(OUTDIR)/thdatabase.o: thdatabase.cxx thdatabase.h thdataobject.h thperson.h \
 thparse.h thbuffer.h thmbuffer.h thdate.h thdataleg.h thobjectname.h \

=== loch/Makefile ===
OUTDIR ?= .
THPLATFORM ?= LINUX
LOUTDIR = ../$(OUTDIR)/loch


# common therion objects
CMNOBJECTS = \
  lxTR.o lxOGLFT.o lxSetup.o lxRender.o lxWX.o \
  lxImgIO.o lxLRUD.o lxFile.o lxSTree.o \
  lxData.o lxMath.o lxSView.o lxSScene.o \
  lxGUI.o lxGLC.o lxOptDlg.o lxAboutDlg.o \
  img.o

# VTKVERSION = 5.4
VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
# VTKPATH = /usr/local/include/vtk-$(VTKVERSION)
VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
# VTKLIBPATH = /usr/local/lib/vtk-$(VTKVERSION)
VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
POSTMAKE =
STRIPFLAG = -s

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS = lxR2P.o
##CXXPFLAGS = -DLXLINUX $(shell wx-config --cxxflags) -Wno-deprecated $(shell freetype-config --cflags) -I$(VTKPATH)
##CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
##LXLIBDIR = linux
##PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lpthread -lz 
##LXPLATFORM = LINUX

# PLATFORM DEBIAN
CXX = c++
CC = gcc
POBJECTS = lxR2P.o
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
CXXPFLAGS = -DLXLINUX $(shell wx-config --cxxflags) -Wno-deprecated $(shell freetype-config --cflags) -I$(VTKPATH)
CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
LXLIBDIR = linux
PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lpthread -lz 
LXPLATFORM = LINUX

# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = loch.res lxR2D.o getline.o
##CXXPFLAGS = -W -Wall -DLXWIN32 $(shell wx-config --static --cxxflags) $(shell freetype-config --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell wx-config --static --cflags)
##LXLIBDIR = mingw
##PLIBS = $(shell freetype-config --libs) $(shell wx-config --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -static -s


# PLATFORM MACOSX
##CXX = c++
##CC = cc
##POBJECTS = 
##CXXPFLAGS = -W -Wall -DLXMACOSX $(shell wx-config --cxxflags) $(shell freetype-config --cflags) -I$(VTKPATH) -Wno-deprecated -I/usr/X11R6/include -I/usr/X11R6/include/freetype2
##CCPFLAGS = -W -Wall -DLXMACOSX $(shell wx-config --cflags) -I/usr/X11R6/include
##LXLIBDIR = 
##PLIBS = -lz -L/usr/X11R6/lib $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##POSTMAKE = cp -f ./loch ./loch.app/Contents/MacOS
##STRIPFLAG =

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(STRIPFLAG)

# BUILD OXYGEN
##CCBFLAGS = -O2
##CXXBFLAGS = -O2
##LDBFLAGS = $(STRIPFLAG)

# BUILD RELEASE
CCBFLAGS = 
CXXBFLAGS = 
LDBFLAGS = $(STRIPFLAG)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DLXDEBUG
##LDBFLAGS = 

# BUILD ENDCONFIG


# compiler settings
CXXFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CXXPFLAGS) $(CXXBFLAGS)
CCFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(LOUTDIR)/,$(POBJECTS)) $(addprefix $(LOUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS = $(PLIBS)
LDFLAGS = $(LDBFLAGS)


$(LOUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<


all: $(LOUTDIR)/loch hlp

hlp:
	make -C ./help

$(LOUTDIR)/loch: $(OBJECTS)
	$(CXX) -o $(LOUTDIR)/loch -Wall $(OBJECTS) $(LIBS) $(LDFLAGS)
	$(POSTMAKE)

$(LOUTDIR)/loch.res: loch.rc loch.ico
	windres -i loch.rc -I ../../wxMSW-2.8.10/include -I rc -o $(LOUTDIR)/loch.res -O coff

graphs: 
	dot -Tps graph-vispipe.dot -o graph-vispipe.ps


depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -DLXDEPCHECK -DLOCH -MM *.cxx >> Makefile
	$(CC) -DLXDEPCHECK -DLOCH -MM *.c >> Makefile
	perl makedepend2.pl
  

config-debug:
	perl makeconfig.pl BUILD DEBUG

test-release:
	zip -9 loch.zip loch.exe test.th test.jpg thconfig
  
config-release:
	perl makeconfig.pl BUILD RELEASE

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN
  
config-ozone:
	perl makeconfig.pl BUILD OZONE
  
config-linux:
	perl makeconfig.pl PLATFORM LINUX

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN
  
config-win32:
	perl makeconfig.pl PLATFORM WIN32
  
config-macosx:
	perl makeconfig.pl PLATFORM MACOSX

clean:
	perl makefile.pl rm -q *~     
	perl makefile.pl rm -q help/*/*~
	perl makefile.pl rm -q loch.exe
	perl makefile.pl rm -q loch
	perl makefile.pl rm -q loch.app/Contents/MacOS/loch
	perl makefile.pl rm -q *.o
	perl makefile.pl rm -q *.log
	perl makefile.pl rm -q core
	perl makefile.pl rmdir -q .xvpics
	perl makefile.pl rm -q *.bmp
	perl makefile.pl rm -q *.ppm
	perl makefile.pl rm -q *.zip
	perl makefile.pl rm -q *.pdf
	perl makefile.pl rm -q *.png
  


# DEPENDENCIES
$(LOUTDIR)/lxAboutDlg.o: lxAboutDlg.cxx lxWX.h icons/about.xpm ../thversion.h
$(LOUTDIR)/lxData.o: lxData.cxx lxData.h lxMath.h lxImgIO.h lxFile.h lxLRUD.h
$(LOUTDIR)/lxFile.o: lxFile.cxx lxFile.h lxMath.h img.h
$(LOUTDIR)/lxGLC.o: lxGLC.cxx lxGLC.h lxMath.h lxGUI.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxSView.h lxWX.h lxFNT6x13_bdf.h lxFNT10x20_bdf.h \
 lxFNTFreeSans_ttf.h lxRender.h lxTR.h
$(LOUTDIR)/lxGUI.o: lxGUI.cxx lxGUI.h lxGLC.h lxMath.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxRender.h lxOptDlg.h lxAboutDlg.h lxSView.h lxWX.h lxSScene.h \
 lxSTree.h icons/open.xpm icons/render.xpm icons/reload.xpm \
 icons/stereo.xpm icons/rotation.xpm icons/lockrot.xpm icons/fit.xpm \
 icons/home.xpm icons/rendersetup.xpm icons/plan.xpm icons/profile.xpm \
 icons/fullscreen.xpm icons/orto.xpm icons/camera.xpm icons/scene.xpm \
 icons/viscline.xpm icons/vissurface.xpm icons/visbbox.xpm \
 icons/viswalls.xpm icons/visinds.xpm icons/visentrance.xpm \
 icons/visfix.xpm icons/visstation.xpm icons/vislabel.xpm loch.xpm
$(LOUTDIR)/lxImgIO.o: lxImgIO.cxx lxImgIO.h
$(LOUTDIR)/lxLRUD.o: lxLRUD.cxx lxLRUD.h lxMath.h
$(LOUTDIR)/lxMath.o: lxMath.cxx lxMath.h
$(LOUTDIR)/lxOGLFT.o: lxOGLFT.cxx lxOGLFT.h
$(LOUTDIR)/lxOptDlg.o: lxOptDlg.cxx lxWX.h lxGUI.h lxGLC.h lxMath.h
$(LOUTDIR)/lxRender.o: lxRender.cxx lxRender.h lxWX.h lxGLC.h lxMath.h lxGUI.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h lxTR.h
$(LOUTDIR)/lxSScene.o: lxSScene.cxx lxSScene.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSTree.o: lxSTree.cxx lxSTree.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSView.o: lxSView.cxx lxSView.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSetup.o: lxSetup.cxx lxSetup.h lxData.h lxMath.h lxImgIO.h lxFile.h
$(LOUTDIR)/lxWX.o: lxWX.cxx lxWX.h
$(LOUTDIR)/getline.o: getline.c
$(LOUTDIR)/img.o: img.c img.h
$(LOUTDIR)/lxR2D.o: lxR2D.c lxR2D.h
$(LOUTDIR)/lxR2P.o: lxR2P.c lxR2P.h
$(LOUTDIR)/lxTR.o: lxTR.c lxTR.h

=== samples/Makefile ===
OUTDIR ?= .

all:
ifneq ($(OUTDIR),.)
	rm -rf ../$(OUTDIR)/samples
	rm -rf ../$(OUTDIR)/samples.doc
	cp -rf ../samples ../$(OUTDIR)
endif
	tclsh samples.tcl $(OUTDIR) ../$(OUTDIR)/samples
ifneq ($(OUTDIR),.)
	perl ../makefile.pl mv samples.log ../$(OUTDIR)/samples
	rm -f samples.log
endif
    
clean:
	tclsh samples.tcl . clean

=== thbook/Makefile ===
OUTDIR ?= .
LOUTDIR = ../$(OUTDIR)/thbook

all: $(LOUTDIR)/thbook.pdf

$(LOUTDIR)/thbook.pdf: *.tex
	pdftex thbook.tex
	pdftex thbook.tex    
	pdftex thbook.tex
	perl ../makefile.pl rm ./thbook.log
ifneq ($(OUTDIR),.)
	perl ../makefile.pl mv ./thbook.pdf $(LOUTDIR)
endif

=== xtherion/Makefile ===
OUTDIR ?= .
THPLATFORM ?= LINUX
LOUTDIR = ../$(OUTDIR)/xtherion

ifeq ($(THPLATFORM),WIN32)
TARGET = xtherion.tcl
else
TARGET = xtherion
endif

all: $(LOUTDIR)/$(TARGET)

$(LOUTDIR)/$(TARGET): *.tcl
	tclsh mkall.tcl
ifneq ($(OUTDIR),.)
	perl ../makefile.pl mv ./$(TARGET) $(LOUTDIR)
endif

survex:
	tclsh mkall.tcl survex
	tar -cvzf ../../../svxedit.tar.gz svxedit
	perl ../makefile.pl rm -q svxedit

clean:
	perl ../makefile.pl rm -q *~
	perl ../makefile.pl rm -q ../../bin/xtherion
	perl ../makefile.pl rm -q lang/*~
	perl ../makefile.pl rm -q svxedit
	perl ../makefile.pl rm -q xtherion.tar.gz
	perl ../makefile.pl rm -q svxedit.tar.gz

update:
	make -C ./lang update
  
msgxth.tcl: lang/xtexts.txt
	make -C ./lang

=== extern/proj4/Makefile ===
OUTDIR ?= .
LOUTDIR = ../../$(OUTDIR)/extern/proj4
OBJECTS = $(addprefix $(LOUTDIR)/,$(addsuffix .o,$(basename $(shell ls *.c))))


$(LOUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -I. -o $@ $<


all: $(LOUTDIR)/libproj.a

$(LOUTDIR)/libproj.a: $(OBJECTS)
	ar cr $(LOUTDIR)/libproj.a $(LOUTDIR)/*.o

remove:
	rm -f proj.c gen_cheb.c p_series.c jniproj.c cs2cs.c \
	cs2cs.c gen_cheb.c p_series.c nad2nad.c nad2bin.c \
	geod.c geod_set.c geod_for.c geod_inv.c geodesic.h

clean:
	perl ../../makefile.pl rm *.o
	perl ../../makefile.pl rm *~
	perl ../../makefile.pl rm *.a

=== debian/changelog ===
therion (5.3.15-2) unstable; urgency=medium

  * Update to use current wx GL API rather than deprecated methods:
    + New patch wx-gl-api-update.patch.
  * Rebuild with wxwidgets3.0 (Closes: #749687):
    + New patch: wx3.0-compat.patch

 -- Olly Betts <olly@survex.com>  Tue, 19 Aug 2014 15:01:27 +1200

therion (5.3.15-1) unstable; urgency=medium

  * New upstream release
  * Add myself to uploaders with maintainer's permission.
  * Update to build with vtk6 (Closes: #750088):
    + New patch: vtk6.patch
  * debian/patches/20debianise-makefiles.patch: Leave the rule for
    therion.res alone - it won't be used on Linux anyway.  Improve added
    dependency to ensure that therion really gets built before trying to
    process the samples.
  * 50svg-logo.patch: Drop patch, and instead ship the therion.svg file it
    creates in the debian directory.

 -- Olly Betts <olly@survex.com>  Sat, 16 Aug 2014 13:42:30 +1200

=== debian/control ===
Source: therion
Section: science
Priority: extra
Maintainer: Wookey <wookey@debian.org>
Uploaders: Olly Betts <olly@survex.com>
Build-Depends: dpkg (>=1.16.2), debhelper (>= 9), perl (>= 5.5), docbook-to-man, tcl, 
  libvtk6-dev, libwxgtk3.0-dev, libfreetype6-dev, libjpeg-dev, libpng-dev, pkg-config, texlive-base
Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript 
Standards-Version: 3.9.5

Package: therion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl, texlive-base, texlive-metapost, bwidget
Recommends: evince | pdf-viewer, libtk-img, therion-viewer, survex
Suggests: survex-aven, texlive-lang-czechslovak, texlive-lang-cyrillic
Description: Cave surveying - 2D and 3D drawing software
 Therion aids the process of drawing up cave surveys (maps). Drawings are 
 done over scans and can be distorted to fit the centreline data. Output is 
 in single sheet or atlas style PDF or SVG files. All data is stored in text 
 files and a map  editor (xtherion) is provided to aid in the creation of the 
 files. A wide range of co-ordinate systems is supported. 
 .
 Therion can also produce 3D models, generated from walls and
 passage-heights.  Output formats supported are Survex .3d files, VRML, DXF,
 SVG, shapefiles, and the native .lox. Scanned map overlays and relief data
 can be incorporated into models. Therion is compatible with Survex, and
 centreline data can be stored in Survex or Therion form. If survex is
 installed it is used for loop closures. Centreline data and sketches can be
 imported from PocketTopo, allowing full paperless surveying.
 .
 TeX and metapost are used to generate the images. libtk-img is needed to use 
 scans in formats other than GIF and PNM (such as PNG and JPEG).
 Survex will be used for loop-closure if installed, but is not required.
 .
 You will need appropriate TeX language packages to process therion files which 
 specify those character sets: Texlive-lang-czechslovak is needed to process 
 the examples, and texlive-lang-cyrillic is also suggested. See README.Debian 
 for details
 


Package: therion-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, therion
Description: Cave surveying - 3D viewer for therion models
 Therion is cave-survey drawing and modelling software. This package contains 
 the 3D model viewer for therion models produced by version 0.4 or later.
 
Package: therion-doc
Section: doc
Architecture: all
Recommends: therion 
Depends: ${misc:Depends}
Replaces: therion (<< 0.5.0)
Description: Documentation for Therion Cave surveying software 
 Therion is cave-survey drawing and modelling software. This package
 includes the thbook which is the specification for the therion data
 description language. This is not the easiest way to get started;
 there is much more documentation in the Therion wiki:
 http://therion.speleo.sk/wiki/doku.php with introductory guides, FAQs
 and examples. Read those first to get an understanding of how it is
 used.

## therion 5.3.16

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 # PLATFORM CONFIG
 
 # PLATFORM LINUX
-##CXX = g++
+##CXX = c++
 ##CC = gcc
 ##POBJECTS =
 ##LOCHEXE = loch/loch
@@ -34,6 +34,7 @@
 ##LDPFLAGS = -s
 ##export THPLATFORM = LINUX
 ##THXTHMKCMD = ./therion
+##OUTDIR = $(abspath $(PWD)/../therion.bin)
 
 
 # PLATFORM DEBIAN
@@ -58,7 +59,7 @@
 ##LDPFLAGS = -static-libgcc -static -s
 ##export THPLATFORM = WIN32
 ##THXTHMKCMD = therion
-##OUTDIR = ../therion.bin
+##OUTDIR = $(abspath $(PWD)/../therion.bin)
 
 # PLATFORM MACOSX
 ##CXX = c++
@@ -310,6 +311,14 @@
 $(OUTDIR)/thcmdline.o: thcmdline.cxx thcmdline.h therion.h thlogfile.h thbuffer.h \
  thconfig.h thmbuffer.h thinput.h thparse.h thexporter.h thexport.h \
  thobjectsrc.h thselector.h thtmpdir.h extern/getopt.h
+$(OUTDIR)/thcomment.o: thcomment.cxx thcomment.h thdataobject.h thdatabase.h \
+ thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h thdataleg.h \
+ thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h loch/lxMath.h \
+ thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h thmapstat.h \
+ thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h thdb2dab.h \
+ thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h thscraplo.h \
+ thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h thdata.h thtfangle.h \
+ thtf.h thtflength.h thtfpwf.h thexception.h
 $(OUTDIR)/thconfig.o: thconfig.cxx thconfig.h thbuffer.h thmbuffer.h thinput.h \
  thparse.h thexporter.h thexport.h thobjectsrc.h thselector.h therion.h \
  thlang.h thlangdata.h thchenc.h thchencdata.h thexception.h thdatabase.h \
@@ -319,7 +328,8 @@
  thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h thscraplo.h \
  thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h thdatareader.h \
  thcsdata.h thproj.h thlogfile.h thinit.h thgeomag.h thgeomagdata.h \
- thlayout.h thsymbolset.h thsymbolsetlist.h thlocale.h thsketch.h thpic.h \
+ thlayout.h thsymbolset.h thsymbolsetlist.h thlocale.h thcomment.h \
+ thdata.h thtfangle.h thtf.h thtflength.h thtfpwf.h thsketch.h thpic.h \
  thcs.h
 $(OUTDIR)/thconvert.o: thconvert.cxx thpdfdbg.h thexception.h therion.h thbuffer.h \
  thpdfdata.h thepsparse.h thtexfonts.h
@@ -334,13 +344,3 @@
 $(OUTDIR)/thcsdata.o: thcsdata.cxx thcsdata.h thparse.h thbuffer.h thmbuffer.h
 $(OUTDIR)/thdata.o: thdata.cxx thdata.h thdataleg.h thparse.h thbuffer.h \
  thmbuffer.h thobjectname.h therion.h thobjectsrc.h thinfnan.h \
- thdataobject.h thdatabase.h thdb1d.h thobjectid.h thdb3d.h loch/lxMath.h \
- thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h thmapstat.h \
- thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h thdb2dab.h \
- thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h thscraplo.h \
- thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h thtfangle.h thtf.h \
- thtflength.h thtfpwf.h thexception.h thsurvey.h thlayout.h thsymbolset.h \
- thsymbolsetlist.h thlocale.h thgrade.h thcsdata.h thdatareader.h \
- thinput.h
-$(OUTDIR)/thdatabase.o: thdatabase.cxx thdatabase.h thdataobject.h thperson.h \
- thparse.h thbuffer.h thmbuffer.h thdate.h thdataleg.h thobjectname.h \

=== loch/Makefile ===
--- 
+++ 
@@ -1,6 +1,11 @@
 OUTDIR ?= .
 THPLATFORM ?= LINUX
-LOUTDIR = ../$(OUTDIR)/loch
+ifneq ($(OUTDIR),.)
+LOUTDIR = $(OUTDIR)/loch
+else
+LOUTDIR = .
+endif
+
 
 
 # common therion objects
@@ -8,16 +13,21 @@
   lxTR.o lxOGLFT.o lxSetup.o lxRender.o lxWX.o \
   lxImgIO.o lxLRUD.o lxFile.o lxSTree.o \
   lxData.o lxMath.o lxSView.o lxSScene.o \
-  lxGUI.o lxGLC.o lxOptDlg.o lxAboutDlg.o \
+  lxGUI.o lxGLC.o lxOptDlg.o lxAboutDlg.o lxPres.o \
   img.o
 
+VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
+VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
+VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
+VTKV6 = $(shell tclsh ./getvtkver.tcl version6)
+ifeq ($(VTKV6),1)
+VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
+else
+VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
+endif
 # VTKVERSION = 5.4
-VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
 # VTKPATH = /usr/local/include/vtk-$(VTKVERSION)
-VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
 # VTKLIBPATH = /usr/local/lib/vtk-$(VTKVERSION)
-VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
-VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
 POSTMAKE =
 STRIPFLAG = -s
 
@@ -27,21 +37,30 @@
 ##CXX = c++
 ##CC = gcc
 ##POBJECTS = lxR2P.o
+##ifeq ($(VTKV6),1)
+##VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
+##else
+##VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
+##endif
 ##CXXPFLAGS = -DLXLINUX $(shell wx-config --cxxflags) -Wno-deprecated $(shell freetype-config --cflags) -I$(VTKPATH)
 ##CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
 ##LXLIBDIR = linux
-##PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lpthread -lz 
+##PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz 
 ##LXPLATFORM = LINUX
 
 # PLATFORM DEBIAN
 CXX = c++
 CC = gcc
 POBJECTS = lxR2P.o
+ifeq ($(VTKV6),1)
+VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
+else
 VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
+endif
 CXXPFLAGS = -DLXLINUX $(shell wx-config --cxxflags) -Wno-deprecated $(shell freetype-config --cflags) -I$(VTKPATH)
 CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
 LXLIBDIR = linux
-PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lpthread -lz 
+PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz 
 LXPLATFORM = LINUX
 
 # PLATFORM WIN32
@@ -78,14 +97,14 @@
 ##LDBFLAGS = $(STRIPFLAG)
 
 # BUILD OXYGEN
-##CCBFLAGS = -O2
-##CXXBFLAGS = -O2
+CCBFLAGS = -O2
+CXXBFLAGS = -O2
+LDBFLAGS = $(STRIPFLAG)
+
+# BUILD RELEASE
+##CCBFLAGS = 
+##CXXBFLAGS = 
 ##LDBFLAGS = $(STRIPFLAG)
-
-# BUILD RELEASE
-CCBFLAGS = 
-CXXBFLAGS = 
-LDBFLAGS = $(STRIPFLAG)
 
 # BUILD DEBUG
 ##CCBFLAGS = -ggdb
@@ -195,7 +214,7 @@
  lxFNTFreeSans_ttf.h lxRender.h lxTR.h
 $(LOUTDIR)/lxGUI.o: lxGUI.cxx lxGUI.h lxGLC.h lxMath.h lxData.h lxImgIO.h lxFile.h \
  lxSetup.h lxRender.h lxOptDlg.h lxAboutDlg.h lxSView.h lxWX.h lxSScene.h \
- lxSTree.h icons/open.xpm icons/render.xpm icons/reload.xpm \
+ lxSTree.h lxPres.h icons/open.xpm icons/render.xpm icons/reload.xpm \
  icons/stereo.xpm icons/rotation.xpm icons/lockrot.xpm icons/fit.xpm \
  icons/home.xpm icons/rendersetup.xpm icons/plan.xpm icons/profile.xpm \
  icons/fullscreen.xpm icons/orto.xpm icons/camera.xpm icons/scene.xpm \
@@ -207,6 +226,8 @@
 $(LOUTDIR)/lxMath.o: lxMath.cxx lxMath.h
 $(LOUTDIR)/lxOGLFT.o: lxOGLFT.cxx lxOGLFT.h
 $(LOUTDIR)/lxOptDlg.o: lxOptDlg.cxx lxWX.h lxGUI.h lxGLC.h lxMath.h
+$(LOUTDIR)/lxPres.o: lxPres.cxx lxPres.h lxWX.h lxGUI.h lxGLC.h lxMath.h lxSetup.h \
+ lxData.h lxImgIO.h lxFile.h loch.xpm
 $(LOUTDIR)/lxRender.o: lxRender.cxx lxRender.h lxWX.h lxGLC.h lxMath.h lxGUI.h \
  lxSetup.h lxData.h lxImgIO.h lxFile.h lxTR.h
 $(LOUTDIR)/lxSScene.o: lxSScene.cxx lxSScene.h lxWX.h lxGUI.h lxGLC.h lxMath.h \

=== samples/Makefile ===
OUTDIR ?= .
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)
else
LOUTDIR = ..
endif


all:
ifneq ($(LOUTDIR),..)
	rm -rf $(LOUTDIR)/samples
	rm -rf $(LOUTDIR)/samples.doc
	cp -rf ../samples $(LOUTDIR)
endif
	tclsh samples.tcl $(LOUTDIR) $(LOUTDIR)/samples
ifneq ($(LOUTDIR),..)
	perl ../makefile.pl mv samples.log $(LOUTDIR)/samples
	rm -f samples.log
endif
    
clean:
	tclsh samples.tcl . clean

=== xtherion/Makefile ===
--- 
+++ 
@@ -1,6 +1,11 @@
 OUTDIR ?= .
 THPLATFORM ?= LINUX
-LOUTDIR = ../$(OUTDIR)/xtherion
+ifneq ($(OUTDIR),.)
+LOUTDIR = $(OUTDIR)/xtherion
+else
+LOUTDIR = .
+endif
+
 
 ifeq ($(THPLATFORM),WIN32)
 TARGET = xtherion.tcl

=== extern/proj4/Makefile ===
--- 
+++ 
@@ -1,5 +1,9 @@
 OUTDIR ?= .
-LOUTDIR = ../../$(OUTDIR)/extern/proj4
+ifneq ($(OUTDIR),.)
+LOUTDIR = $(OUTDIR)/extern/proj4
+else
+LOUTDIR = .
+endif
 OBJECTS = $(addprefix $(LOUTDIR)/,$(addsuffix .o,$(basename $(shell ls *.c))))

=== debian/changelog ===
therion (5.3.16-7build2) wily; urgency=medium

  * No-change rebuild for vtk 6.2.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 30 Aug 2015 12:48:17 +0200

therion (5.3.16-7build1) wily; urgency=medium

  * No-change rebuild against libwx*-0v5

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 10 Aug 2015 12:29:06 +0200

therion (5.3.16-7) unstable; urgency=medium

  * Upload to unstable.
  * debian/control: Add "Homepage" field.
  * debian/control: Punctuation tweaks for descriptions.
  * "Standards-Version: 3.9.6" (no changes required).
  * debian/copyright: Fix lintian warnings.
  * 30doc-fixes.patch,35loch-manpage.patch: Improve man pages:
    + Document that xtherion and loch accept filenames on the command line.
    + Reference loch man pages from others.
    + Fix incorrect paths to thbook.pdf.
    + Note PNG and JPEG are supported image formats if libtk-img is installed.
  * therion.desktop,therion-viewer.desktop:
    + Add %f or %F as appropriate to Exec.
    + Drop deprecated "Encoding=UTF-8".
  * debian/watch: Remove template comment.

 -- Olly Betts <olly@survex.com>  Wed, 20 May 2015 20:53:34 +1200

therion (5.3.16-6) experimental; urgency=low

  * Rebase packaging on top of the actually uploaded 5.3.15-2 (which will be
    in jessie) rather than a never uploaded version of 5.3.15-1.
  * Fix long delay processing large log files (Closes: #751471)
    + New patch: fix-log-file-regexp-backtracking.patch
  * Fix a couple of remaining wx3.0 issues.
    + New patch: wx3.0-leftovers.patch
  * debian/copyright: Fix "Licence:" to "License:", noted by lintian.
  * Drop unused therion-document-missing-cs.patch as it's been applied
    upstream.
  * Update 20debianise-makefiles.patch and 25debianize-loch-makefile.patch so
    that all hardening flags get used.

 -- Olly Betts <olly@survex.com>  Tue, 13 Jan 2015 16:12:21 +1300

therion (5.3.16-5) experimental; urgency=low

  * Remove redundant patches from patches dir
    Update copyright file to cover 'extern' files
    Apply fix-altitude-colours-with-centreline patch 

 -- Wookey <wookey@debian.org>  Thu, 08 Jan 2015 00:46:45 +0000

therion (5.3.16-4) experimental; urgency=medium

  * Remove now-unnecessary nolang-segfault-fix patch

 -- Wookey <wookey@debian.org>  Wed, 07 Jan 2015 22:35:05 +0000

therion (5.3.16-3) experimental; urgency=medium

  * Include missing libproj build-dep

 -- Wookey <wookey@debian.org>  Mon, 05 Jan 2015 22:09:29 +0000

therion (5.3.16-2) experimental; urgency=medium

  * Use external libproj instead of internal (Closes: 758268)

 -- Wookey <wookey@debian.org>  Mon, 05 Jan 2015 13:31:35 +0000

therion (5.3.16-1) experimental; urgency=medium

  * New upstream release

 -- Wookey <wookey@debian.org>  Mon, 29 Dec 2014 23:42:52 +0000

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,10 @@
 Maintainer: Wookey <wookey@debian.org>
 Uploaders: Olly Betts <olly@survex.com>
 Build-Depends: dpkg (>=1.16.2), debhelper (>= 9), perl (>= 5.5), docbook-to-man, tcl, 
-  libvtk6-dev, libwxgtk3.0-dev, libfreetype6-dev, libjpeg-dev, libpng-dev, pkg-config, texlive-base
+  libvtk6-dev, libwxgtk3.0-dev, libfreetype6-dev, libjpeg-dev, libpng-dev, pkg-config, texlive-base, libproj-dev
 Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript 
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
+Homepage: http://therion.speleo.sk/
 
 Package: therion
 Architecture: any
@@ -17,7 +18,7 @@
  Therion aids the process of drawing up cave surveys (maps). Drawings are 
  done over scans and can be distorted to fit the centreline data. Output is 
  in single sheet or atlas style PDF or SVG files. All data is stored in text 
- files and a map  editor (xtherion) is provided to aid in the creation of the 
+ files and a map editor (xtherion) is provided to aid in the creation of the 
  files. A wide range of co-ordinate systems is supported. 
  .
  Therion can also produce 3D models, generated from walls and
@@ -33,9 +34,9 @@
  Survex will be used for loop-closure if installed, but is not required.
  .
  You will need appropriate TeX language packages to process therion files which 
- specify those character sets: Texlive-lang-czechslovak is needed to process 
+ specify those character sets: texlive-lang-czechslovak is needed to process 
  the examples, and texlive-lang-cyrillic is also suggested. See README.Debian 
- for details
+ for details.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

clean:
	dh_testdir
	dh_testroot
	# Add here commands to clean up after the build process.
	rm -f man/therion-viewer.1
	$(MAKE) -C samples clean
	dh_auto_clean
	dh_clean

build: build-arch build-indep

build-indep:
	# just build the -doc package 
	dh_testdir
        

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	# We need therion itself to build the samples
	$(MAKE) therion 
	# create HTML documentation for samples
	$(MAKE) samples
endif
	$(MAKE) thbook
	touch build-indep-stamp

build-arch:
	dh_testdir
	# Compile the binaries
	$(MAKE) therion xtherion/xtherion loch/loch
	ln -sf loch.1 man/therion-viewer.1
	# create therion.ini file:
	#$(MAKE) init
	touch build-arch-stamp

binary: binary-arch binary-indep

# Package architecture-independent packages here.
binary-indep: DH_OPTIONS=-i
binary-indep: build-indep-stamp
	# just build the -doc package 
	dh_testdir
	dh_testroot

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	#if cross-building these won't have been generated, so skip
	dh_installdocs -ptherion-doc samples.doc
endif
	dh_install -Ntherion-viewer -Ntherion
	#we should generate html of thbook here too if possible
	dh_compress -ptherion-doc -X.pdf -X.th -X.th2 -Xthconfig
	dh_fixperms -Ntherion-viewer -Ntherion
	dh_installdeb -Ntherion-viewer -Ntherion
	dh_gencontrol -Ntherion-viewer -Ntherion
	dh_md5sums -Ntherion-viewer -Ntherion
	dh_builddeb -Ntherion-viewer -Ntherion

# Package architecture-dependent files here.
binary-arch: DH_OPTIONS=-a
binary-arch: build-arch-stamp 
	dh_testdir
	dh_testroot
	dh_installdirs

	# Add here commands to install the package into debian/therion.
#this stuff no longer needed from 0.2.14
#but it would be nice to put it back
#	install -d -o root -g root -m 755 debian/therion/usr/share/texmf/metapost/therion
#	install -d -o root -g root -m 755 debian/therion/usr/share/texmf/tex/therion
#	install -p -o root -g root -m 644 mpost/*.mp debian/therion/usr/share/texmf/metapost/therion/
#	install -p -o root -g root -m 644 tex/*.tex debian/therion/usr/share/texmf/tex/therion/
	dh_install -Ntherion-doc
	dh_installdocs README
	dh_installdocs -ptherion-viewer loch/help/en/loch.htm
	# we need to clear out large generated files from samples before putting just source files in main package
	$(MAKE) -C samples clean
	dh_installexamples -ptherion  --exclude=.tcl --exclude=Makefile --exclude=thTMPDIR samples thconfig therion.ini
	dh_installmenu
	dh_installmime
	dh_icons
	dh_installman -ptherion man/therion.1 man/xtherion.1
	dh_installman -ptherion-viewer man/loch.1 man/therion-viewer.1
	dh_installchangelogs CHANGES
	dh_strip
	dh_compress -X.pdf -X.th -X.th2 -Xthconfig
	dh_fixperms -Ntherion-doc
	dh_installdeb -Ntherion-doc
	dh_shlibdeps -Ntherion-doc
	dh_gencontrol -Ntherion-doc
	dh_md5sums -Ntherion-doc
	dh_builddeb -Ntherion-doc

.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
# Run the "uscan" command to check for upstream updates.
version=3
http://therion.speleo.sk/download.php  downloads/therion-(.*)\.tar\.gz debian uupdate
